# Mdulo Peticionamento e Intimao Eletrnicos

## Requisitos:
- SEI 3.0.2 instalado/atualizado ou verso superior (verificar valor da constante de verso do SEI no arquivo /sei/web/SEI.php).
	- **IMPORTANTE**, no caso de atualizao do presente mdulo: A atualizao do SEI 2.6 para 3.0 alterou diversas tabelas que as tabelas do mdulo relacionava. Dessa forma, alertamos que, imediatamente ANTES de executar o script de atualizao do SEI 3.0  necessrio executar o script abaixo no banco do SEI para que a atualizao do SEI 3.0 possa ocorrer sem erro:
		
		ALTER TABLE `md_pet_rel_tp_ctx_contato` DROP FOREIGN KEY `fk_md_pet_rel_tp_ctx_cont_1`;
		
- Antes de executar os scripts de instalao/atualizao (itens 4 e 5 abaixo), o usurio de acesso aos bancos de dados do SEI e do SIP, constante nos arquivos ConfiguracaoSEI.php e ConfiguracaoSip.php, dever ter permisso de acesso total ao banco de dados, permitindo, por exemplo, criao e excluso de tabelas.

## Procedimentos para Instalao:

1. Antes, fazer backup dos bancos de dados do SEI e do SIP.

2. Carregar no servidor os arquivos do mdulo localizados na pasta "/sei/web/modulos/peticionamento" e os scripts de instalao/atualizao "/sei/scripts/sei_atualizar_versao_modulo_peticionamento.php" e "/sip/scripts/sip_atualizar_versao_modulo_peticionamento.php".

3. Editar o arquivo "/sei/config/ConfiguracaoSEI.php", tomando o cuidado de usar editor que no altere o charset do arquivo, para adicionar a referncia  classe de integrao do mdulo e seu caminho relativo dentro da pasta "/sei/web/modulos" na array 'Modulos' da chave 'SEI':

		'SEI' => array(
			'URL' => 'http://[Servidor_PHP]/sei',
			'Producao' => false,
			'RepositorioArquivos' => '/var/sei/arquivos',
			'Modulos' => array('PeticionamentoIntegracao' => 'peticionamento',)
			),

4. Rodar o script de banco "/sei/scripts/sei_atualizar_versao_modulo_peticionamento.php" em linha de comando no servidor do SEI, verificando se no houve erro em sua execuo, em que ao final do log dever ser informado "FIM". Exemplo de comando de execuo:

		/usr/bin/php -c /etc/php.ini /opt/sei/scripts/sei_atualizar_versao_modulo_peticionamento.php > atualizacao_modulo_peticionamento_sei.log

5. Rodar o script de banco "/sip/scripts/sip_atualizar_versao_modulo_peticionamento.php" em linha de comando no servidor do SIP, verificando se no houve erro em sua execuo, em que ao final do log dever ser informado "FIM". Exemplo de comando de execuo:

		/usr/bin/php -c /etc/php.ini /opt/sip/scripts/sip_atualizar_versao_modulo_peticionamento.php > atualizacao_modulo_peticionamento_sip.log

6. Aps a execuo com sucesso, com um usurio com permisso de Administrador no SEI, seguir os passos dispostos no tpico Orientaes Negociais, abaixo.

7. **IMPORTANTE**: Na execuo dos dois scripts acima, ao final deve constar o termo "FIM" e informao de que a instalao ocorreu com sucesso (SEM ERROS). Do contrrio, o script no foi executado at o final e algum dado no foi inserido/atualizado no banco de dados correspondente, devendo recuperar o backup do banco pertinente e repetir o procedimento.
		- Constando o termo "FIM" e informao de que a instalao ocorreu com sucesso, pode logar no SEI e SIP e verificar no menu Infra > Parmetros se consta o parmetro "VERSAO_MODULO_PETICIONAMENTO" com o valor da ltima verso do mdulo.

8. Em caso de erro durante a execuo do script verificar (lendo as mensagens de erro e no menu Infra > Log do SEI e do SIP) se a causa  algum problema na infra-estrutura local. Neste caso, aps a correo, deve recuperar o backup do banco pertinente e repetir o procedimento, especialmente a execuo dos scripts indicados nos itens 4 e 5 acima.
	- Caso no seja possvel identificar a causa, entrar em contato com: Nei Jobson - neijobson@anatel.gov.br

## Orientaes Negociais:

1. Imediatamente aps a instalao com sucesso, com usurio com permisso de "Administrador" do SEI,  necessrio realizar as parametrizaes do mdulo no menu Administrao > Peticionamento Eletrnico, para que o mdulo seja utilizado adequadamente pelos Usurios Externos na tela de Acesso Externo do SEI:

		http://[Servidor_PHP]/sei/controlador_externo.php?acao=usuario_externo_logar&id_orgao_acesso_externo=0

2. Ainda com usurio com permisso de "Administrador" do SEI,  necessrio cadastrar os "Cargos", "Tratamentos", "Vocativos" e "Tipos" no menu Administrao > Contatos.
	- Os "Cargos" sero utilizados pelos Usurios Externos na seleo do "Cargo/Funo" na assinatura de cada Peticionamento e tambm no cadastro de novos Interessados.
	- Os demais registros acima sero utilizados no cadastro de novos Interessados pelos Usurios Externos.
	- Caso a instalao do SEI do rgo no possua as parametrizaes acima, sugerimos como exemplo a lista disponibilizada no link a seguir, mapeada no mbito do PEN: [https://goo.gl/NqikRu](https://goo.gl/NqikRu "Clique e acesse")

3. Outro ponto importante  a parametrizao do menu Administrao > Peticionamento Eletrnico > Hipteses Legais Permitidas. Contudo, antes, exige que no menu Administrao > Hipteses Legais > Listar j contenha uma lista bem definida de uso pelo rgo, com todas as opes legais aplicveis, inclusive em razo de Lei prprio do rgo, pois, na medida que se disponibiliza Hipteses Legais aplicveis, melhor sero as indicaes de Restrio.
	- Caso a instalao do SEI do rgo no possua lista de Hipteses Legais ou a lista tenha poucas opes, sugerimos como exemplo a lista disponibilizada no link a seguir, mapeada no mbito do PEN: [https://goo.gl/JzycpM](https://goo.gl/JzycpM "Clique e acesse")

4. Ateno especial para as parametrizaes de Aplicabilidade dos Tipos de Documentos, pois os Tipos com Aplicabilidade "Documentos Externos" e "Documentos Internos e Externos" so apresentados como opes de Tipos de Documentos na Administrao > Peticionamento Eletrnico > Tipos para Peticionamento na indicao dos Tipos permitidos para Documento Principal, Essenciais e Complementares e, ainda, na tela dos Usurios Externos na tela de Peticionamento Intercorrente no combo "Tipo de Documento". Importante lembrar que a lista de Tipos de Documentos Externos devem ser de Espcies Documentais, ou seja, deve ser sempre complementado.
	- Caso a instalao do SEI do rgo no possua lista adequada de Tipos de Documentos com as Aplicabilidades acima, sugerimos como exemplo a lista disponibilizada no link a seguir, mapeada no mbito do PEN: [https://goo.gl/1JuEqA](https://goo.gl/1JuEqA "Clique e acesse")

5. Destacamos que a janela de Cadastro de Interessado na tela de Peticionamento de Processo Novo  aberta ao Validar CPF ou CPNJ em duas situaes: (i) quando o CPF ou CNPJ no existir na tabela "contato" no banco do SEI ou (ii) quando existir mais de um registro na referida tabela com o mesmo CPF ou CNPJ. A segunda regra visa a priorizar o cadastro novo feito por meio do mdulo pelo prprio Usurio Externo, que geralmente possui mais dados sobre o Interessado.
	- **IMPORTANTE**: sugere-se que o rgo faa uma extrao da tabela "contato" e faa anlises para levantar os cadastros com CPF ou CNPJ duplicados, para resolver as duplicaes, mantendo um s cadastro por CPF ou CNPJ.

6. Peticionamento Intercorrente:
	- Os Usurios Externos somente visualizaro o menu Peticionamento > Intercorrente depois que na Administrao for configurado pelo menos o "Intercorrente Padro".
	- A abertura de processo novo relacionado ao processo de fato indicado pelo Usurio Externo ocorrer quando este corresponder a processo: 1) de Tipo de Processo sem Critrio Intercorrente parametrizado; 2) com Nvel de Acesso "Sigiloso"; 3) Sobrestado, Anexado ou Bloqueado; ou 4) de Tipo de Processo desativado.
		- Em todos os casos acima a forma de indicao de Nvel de Acesso pelo Usurio Externo ser a indicada em Administrao > Peticionamento Eletrnico > Critrios para Intercorrente > boto "Intercorrente Padro". Somente no caso 4  que o Tipo de Processo tambm ser o indicado para "Intercorrente Padro".
	- Se TODAS as Unidades por onde o processo indicado tenha tramitado estiverem Desativadas no SEI, o Usurio Externo ser avisado que o Peticionamento Intercorrente no  possvel, devendo utilizar a funcionalidade de Peticionamento de Processo Novo.

7. No foi possvel fazer um Manual do Usurio Externo genrico para qualquer rgo, em razo das especificidades de cada rgo quanto aos procedimentos de credenciamento dos Usurios Externos e at mesmo de parametrizao do Mdulo. De qualquer forma, segue link para o Manual do Usurio Externo do SEI elaborado pela Anatel que pode ser quase que completamente aproveitado para elaborao de outros Manuais: [https://goo.gl/eyJr12](https://goo.gl/eyJr12 "Clique e acesse")

8. Acesse o Manual de Administrao do Mdulo (ainda em construo): [https://goo.gl/pqIoZY](https://goo.gl/pqIoZY "Clique e acesse")

9. Ainda, conforme pode ser observado no Manual do Usurio Externo disponibilizado no item 7 acima,  extremamente recomendado que o rgo tenha bem definido procedimento para cadastro e liberao de Usurios Externos no SEI, preferencialmente com assinatura e entrega de "Termo de Declarao de Concordncia e Veracidade" juntamente com documento que contenha nmero de CPF.
	- Segue link para exemplo de Termo que pode ser utilizado, desde que ajuste a indicao do endereo para envio da correspondncia. Sugerimos que seja disponibilizado em formato PDF: [https://goo.gl/u7dfFs](https://goo.gl/u7dfFs "Clique e acesse")

10. Por fim, no  aconselhvel dar publicidade a registros de indisponibilidades do SEI at que o mdulo possua funcionalidades afetas a Intimao Eletrnica, prevista para a verso 2.0. De qualquer forma, segue URL da pgina pblica que lista os cadastrados realizados no menu Administrao > Peticionamento Eletrnico > Indisponibilidades do SEI:

		http://[Servidor_PHP]/sei/modulos/peticionamento/md_pet_usu_ext_indisponibilidade_lista.php?acao_externa=md_pet_usu_ext_indisponibilidade_listar&id_orgao_acesso_externo=0