<?php
/**
 * ANATEL
 *
 * 21/07/2016 - criado por marcelo.bezerra - CAST
 *
 */
require_once dirname(__FILE__).'/../../../SEI.php';

class MdPetProcedimentoRN extends ProcedimentoRN {
	
	//METODO SOBRESCRITO DA RN ORIGINAL POR CONTA DE USUARIO EXTERNO
	 public function gerarRN0156(ProcedimentoDTO $objProcedimentoDTO){

	    $bolAcumulacaoPrevia = FeedSEIProtocolos::getInstance()->isBolAcumularFeeds();
	
	    FeedSEIProtocolos::getInstance()->setBolAcumularFeeds(true);	
	    $objProcedimentoDTO = $this->gerarRN0156Interno($objProcedimentoDTO);	    
	    $objIndexacaoDTO = new IndexacaoDTO();
	    $objIndexacaoRN = new IndexacaoRN();
	
	    $objProtocoloDTO = new ProtocoloDTO();
	    $objProtocoloDTO->setDblIdProtocolo($objProcedimentoDTO->getDblIdProcedimento());
	    //seiv2
            // $objIndexacaoDTO->setArrObjProtocoloDTO(array($objProtocoloDTO));
	    //alteracoes seiv3
            $objIndexacaoDTO->setArrIdProtocolos(array($objProtocoloDTO->getDblIdProtocolo()));
            //seiv2
            //$objIndexacaoDTO->setStrStaOperacao(IndexacaoRN::$TO_GERACAO_PROTOCOLO);
	    
            //alteracoes seiv3
            $objIndexacaoDTO->setStrStaOperacao(IndexacaoRN::$TO_PROTOCOLO_METADADOS);
            
	    $objIndexacaoRN->indexarProtocolo($objIndexacaoDTO);
	
	    if (!$bolAcumulacaoPrevia){
	      FeedSEIProtocolos::getInstance()->setBolAcumularFeeds(false);
	      FeedSEIProtocolos::getInstance()->indexarFeeds();
	    }
            
	    return $objProcedimentoDTO;
  }
  
  //METODO SOBRESCRITO DA RN ORIGINAL POR CONTA DE USUARIO EXTERNO
  protected function gerarRN0156InternoControlado(ProcedimentoDTO $objProcedimentoDTO) {

      //Valida Permissao
      //SessaoSEI::getInstance()->validarAuditarPermissao('procedimento_gerar',__METHOD__,$objProcedimentoDTO);
     try {
     	
      //Regras de Negocio
      $objInfraException = new InfraException();
      
      $this->validarNumIdTipoProcedimentoRN0204($objProcedimentoDTO, $objInfraException);
      $this->validarStrSinGerarPendenciaRN0901($objProcedimentoDTO, $objInfraException);
      $this->validarAnexosRN0751($objProcedimentoDTO, $objInfraException);
      $this->validarNivelAcesso($objProcedimentoDTO, $objInfraException); //valida somente no cadastro
      $this->validarProcessoIndividual($objProcedimentoDTO, $objInfraException);
      $objInfraException->lancarValidacoes();
  
      $objProtocoloRN = new MdPetProtocoloRN();
      
      $objProtocoloDTO = $objProcedimentoDTO->getObjProtocoloDTO();
      
      if (!$objProtocoloDTO->isSetStrProtocoloFormatado()){
        $objProtocoloDTO->setStrProtocoloFormatado(null);
      }
      
      $objProtocoloDTO->setStrStaProtocolo(ProtocoloRN::$TP_PROCEDIMENTO);
      
      if (!$objProtocoloDTO->isSetDtaGeracao() || InfraString::isBolVazia($objProtocoloDTO->getDtaGeracao()))
        $objProtocoloDTO->setDtaGeracao(InfraData::getStrDataAtual());
      
      $objProcedimentoDTO->setObjProtocoloDTO($objProtocoloDTO);
      
      $objProtocoloDTOGerado = $objProtocoloRN->gerarRN0154($objProcedimentoDTO->getObjProtocoloDTO());
      
      $objProcedimentoDTO->setDblIdProcedimento($objProtocoloDTOGerado->getDblIdProtocolo());

      $arrObjAtributoAndamentoDTO = array();
      $objAtributoAndamentoDTO = new AtributoAndamentoDTO();
      $objAtributoAndamentoDTO->setStrNome('NIVEL_ACESSO');
      $objAtributoAndamentoDTO->setStrValor(null);
      $objAtributoAndamentoDTO->setStrIdOrigem($objProcedimentoDTO->getObjProtocoloDTO()->getStrStaNivelAcessoLocal());
      $arrObjAtributoAndamentoDTO[] = $objAtributoAndamentoDTO;      

      if( $objProcedimentoDTO->getObjProtocoloDTO()->isSetNumIdHipoteseLegal() && !InfraString::isBolVazia($objProcedimentoDTO->getObjProtocoloDTO()->getNumIdHipoteseLegal())){
        $objAtributoAndamentoDTO = new AtributoAndamentoDTO();
        $objAtributoAndamentoDTO->setStrNome('HIPOTESE_LEGAL');
        $objAtributoAndamentoDTO->setStrValor(null);
        $objAtributoAndamentoDTO->setStrIdOrigem($objProcedimentoDTO->getObjProtocoloDTO()->getNumIdHipoteseLegal());
        $arrObjAtributoAndamentoDTO[] = $objAtributoAndamentoDTO;
      }
      
      if (!InfraString::isBolVazia($objProcedimentoDTO->getObjProtocoloDTO()->getStrStaGrauSigilo())){
        $objAtributoAndamentoDTO = new AtributoAndamentoDTO();
        $objAtributoAndamentoDTO->setStrNome('GRAU_SIGILO');
        $objAtributoAndamentoDTO->setStrValor(null);
        $objAtributoAndamentoDTO->setStrIdOrigem($objProcedimentoDTO->getObjProtocoloDTO()->getStrStaGrauSigilo());
        $arrObjAtributoAndamentoDTO[] = $objAtributoAndamentoDTO;
      }
      
      if ($objProcedimentoDTO->getObjProtocoloDTO()->getDtaGeracao()!=InfraData::getStrDataAtual()){
        $objAtributoAndamentoDTO = new AtributoAndamentoDTO();
        $objAtributoAndamentoDTO->setStrNome('DATA_AUTUACAO');
        $objAtributoAndamentoDTO->setStrValor($objProcedimentoDTO->getObjProtocoloDTO()->getDtaGeracao());
        $objAtributoAndamentoDTO->setStrIdOrigem(null);
        $arrObjAtributoAndamentoDTO[] = $objAtributoAndamentoDTO;
      }
            
      $objAtividadeDTO = new AtividadeDTO();
      $objAtividadeDTO->setDblIdProtocolo($objProcedimentoDTO->getDblIdProcedimento());      
      $objAtividadeDTO->setNumIdUnidade($objProtocoloDTO->getNumIdUnidadeGeradora());
      $objAtividadeDTO->setNumIdTarefa(TarefaRN::$TI_GERACAO_PROCEDIMENTO);
      $objAtividadeDTO->setArrObjAtributoAndamentoDTO($arrObjAtributoAndamentoDTO);
      
      $numUnidadeGeradora = $objProtocoloDTO->getNumIdUnidadeGeradora();
	  $objAtividadeRN = new MdPetAtividadeRN();
	  
	  $param = array();
	  $param[0] = $objAtividadeDTO;
	  $param[1] = $numUnidadeGeradora;
	  
	  $ret = $objAtividadeRN->gerarInternaRN0727Customizado( $param );
 
      //Associar o processo e seus documentos com esta unidade
	  $objAssociarDTO = new AssociarDTO();	  	
	  $objAssociarDTO->setDblIdProcedimento($objProcedimentoDTO->getDblIdProcedimento());
	  
	  //seiv2 ( comentado por alteracoes seiv3 )
	  //$objAssociarDTO->setDblIdDocumento(null);
	  $objAssociarDTO->setNumIdUnidade($objProtocoloDTO->getNumIdUnidadeGeradora());
	  $objAssociarDTO->setNumIdUsuario($objProtocoloDTO->getNumIdUsuarioGerador());
	  $objAssociarDTO->setStrStaNivelAcessoGlobal($objProtocoloDTOGerado->getStrStaNivelAcessoGlobal());
	  $objProtocoloRN->associarRN0982($objAssociarDTO); 					  
	
	  if ($objProcedimentoDTO->getStrSinGerarPendencia()=='N'){
	    $objAtividadeRN->concluirRN0726(array($ret));
	  }
	
	  $objProcedimentoDTO->setStrStaOuvidoria(ProcedimentoRN::$TFO_NENHUM);
	  $objProcedimentoDTO->setStrSinCiencia('N');
			
      $objProcedimentoBD = new ProcedimentoBD($this->getObjInfraIBanco());
      $objProcedimentoBD->cadastrar($objProcedimentoDTO);
      
      $objProcedimentoDTO->setStrStaNivelAcessoGlobalProtocolo($objProtocoloDTOGerado->getStrStaNivelAcessoGlobal());
      $this->lancarAcessoControleInterno($objProcedimentoDTO);
      
      $objTipoProcedimentoEscolhaDTO = new TipoProcedimentoEscolhaDTO();
      $objTipoProcedimentoEscolhaDTO->setNumIdTipoProcedimento($objProcedimentoDTO->getNumIdTipoProcedimento());
      $objTipoProcedimentoEscolhaDTO->setNumIdUnidade( $objProtocoloDTO->getNumIdUnidadeGeradora()  );
      
      $objTipoProcedimentoEscolhaRN = new TipoProcedimentoEscolhaRN();
      
      if ($objTipoProcedimentoEscolhaRN->contar($objTipoProcedimentoEscolhaDTO)==0){
      	$objTipoProcedimentoEscolhaRN->cadastrar($objTipoProcedimentoEscolhaDTO);
      }

      if ($objProcedimentoDTO->isSetArrObjRelProtocoloProtocoloDTO()){

        $arrObjProtocoloProtocoloDTO = $objProcedimentoDTO->getArrObjRelProtocoloProtocoloDTO();

        foreach($arrObjProtocoloProtocoloDTO as $objRelProtocoloProtocoloDTO){
          $objRelProtocoloProtocoloDTO->setDblIdProtocolo2($objProtocoloDTOGerado->getDblIdProtocolo());
          $objRelProtocoloProtocoloDTO->setStrStaAssociacao(RelProtocoloProtocoloRN::$TA_PROCEDIMENTO_RELACIONADO);
          $this->relacionarProcedimentoRN1020($objRelProtocoloProtocoloDTO);
        }
      }
      
      $objProcedimentoDTO = new ProcedimentoDTO(true);
	  $objProcedimentoDTO->setDblIdProcedimento($objProtocoloDTOGerado->getDblIdProtocolo());
	  $objProcedimentoDTO->setStrProtocoloProcedimentoFormatado($objProtocoloDTOGerado->getStrProtocoloFormatado());
      
      return $objProcedimentoDTO;

     } catch(Exception $e){
         throw new InfraException('Erro gerando Processo.',$e);
     }
  }
  
  //MTODOS SOBRESCRITOS PORQUE NO PAI ESTAVA COMO PRIVATE E NAO PERMITIA CHAMAR
  private function validarNumIdTipoProcedimentoRN0204(ProcedimentoDTO $objProcedimentoDTO, InfraException $objInfraException){
  	if (InfraString::isBolVazia($objProcedimentoDTO->getNumIdTipoProcedimento())){
  		$objInfraException->adicionarValidacao('Tipo do Processo no informado.');
  	}
  }
  
  //MTODOS SOBRESCRITOS PORQUE NO PAI ESTAVA COMO PRIVATE E NAO PERMITIA CHAMAR
  private function validarStrSinGerarPendenciaRN0901(ProcedimentoDTO $objProcedimentoDTO, InfraException $objInfraException){
  	if (InfraString::isBolVazia($objProcedimentoDTO->getStrSinGerarPendencia())){
  		$objInfraException->adicionarValidacao('Sinalizador de gerao de andamento automtico no informado.');
  	}else{
  		if (!InfraUtil::isBolSinalizadorValido($objProcedimentoDTO->getStrSinGerarPendencia())){
  			$objInfraException->adicionarValidacao('Sinalizador de gerao de andamento automtico invlido.');
  		}
  	}
  }
  
  //MTODOS SOBRESCRITOS PORQUE NO PAI ESTAVA COMO PRIVATE E NAO PERMITIA CHAMAR
  private function validarStrSinCiencia(ProcedimentoDTO $objProcedimentoDTO, InfraException $objInfraException){
  	if (InfraString::isBolVazia($objProcedimentoDTO->getStrSinCiencia())){
  		$objInfraException->adicionarValidacao('Sinalizador de cincia no informado.');
  	}else{
  		if (!InfraUtil::isBolSinalizadorValido($objProcedimentoDTO->getStrSinCiencia())){
  			$objInfraException->adicionarValidacao('Sinalizador de cincia invlido.');
  		}
  	}
  }
  
  //MTODOS SOBRESCRITOS PORQUE NO PAI ESTAVA COMO PRIVATE E NAO PERMITIA CHAMAR
  private function validarAnexosRN0751(ProcedimentoDTO $objProcedimentoDTO, InfraException $objInfraException){
  
  }
  
  //MTODOS SOBRESCRITOS PORQUE NO PAI ESTAVA COMO PRIVATE E NAO PERMITIA CHAMAR
  private function validarNivelAcesso(ProcedimentoDTO $objProcedimentoDTO, InfraException $objInfraException){
  	 
  	$objMdPetProtocoloRN = new MdPetProtocoloRN();
  	$objMdPetProtocoloRN->validarStrStaNivelAcessoLocalRN0685($objProcedimentoDTO->getObjProtocoloDTO(),$objInfraException);
  	 
  	$objNivelAcessoPermitidoDTO = new NivelAcessoPermitidoDTO();
  	$objNivelAcessoPermitidoDTO->setNumIdTipoProcedimento($objProcedimentoDTO->getNumIdTipoProcedimento());
  	$objNivelAcessoPermitidoDTO->setStrStaNivelAcesso($objProcedimentoDTO->getObjProtocoloDTO()->getStrStaNivelAcessoLocal());
  
  	$objNivelAcessoPermitidoRN = new NivelAcessoPermitidoRN();
  	if ($objNivelAcessoPermitidoRN->contar($objNivelAcessoPermitidoDTO)==0){
  		$objInfraException->adicionarValidacao('Nvel de acesso no permitido para o tipo de procedimento.');
  	}
  }
  
  //MTODOS SOBRESCRITOS PORQUE NO PAI ESTAVA COMO PRIVATE E NAO PERMITIA CHAMAR
  private function validarProcessoIndividual(ProcedimentoDTO $parObjProcedimentoDTO, InfraException $objInfraException){
  
  	$objTipoProcedimentoDTO = new TipoProcedimentoDTO();
  	$objTipoProcedimentoDTO->setBolExclusaoLogica(false);
  	$objTipoProcedimentoDTO->retStrNome();
  	$objTipoProcedimentoDTO->retStrSinIndividual();
  	$objTipoProcedimentoDTO->setNumIdTipoProcedimento($parObjProcedimentoDTO->getNumIdTipoProcedimento());
  
  	$objTipoProcedimentoRN = new TipoProcedimentoRN();
  	$objTipoProcedimentoDTO = $objTipoProcedimentoRN->consultarRN0267($objTipoProcedimentoDTO);
  
  	if ($objTipoProcedimentoDTO->getStrSinIndividual()=='S'){
  
  		if ($parObjProcedimentoDTO->isSetObjProtocoloDTO() && $parObjProcedimentoDTO->getObjProtocoloDTO()->isSetArrObjParticipanteDTO()){
  			$arrObjParticipanteDTO = $parObjProcedimentoDTO->getObjProtocoloDTO()->getArrObjParticipanteDTO();
  		}else{
  			$objParticipanteDTO = new ParticipanteDTO();
  			$objParticipanteDTO->retNumIdContato();
  			$objParticipanteDTO->setDblIdProtocolo($parObjProcedimentoDTO->getDblIdProcedimento());
  			$objParticipanteDTO->setStrStaParticipacao(ParticipanteRN::$TP_INTERESSADO);
  
  			$objParticipanteRN = new ParticipanteRN();
  			$arrObjParticipanteDTO = $objParticipanteRN->listarRN0189($objParticipanteDTO);
  		}
  
  		$numInteressadosUsuario = 0;
  		$objParticipanteDTOUsuario = null;
  		foreach($arrObjParticipanteDTO as $objParticipanteDTO){
  			if ($objParticipanteDTO->getStrStaParticipacao()==ParticipanteRN::$TP_INTERESSADO){
  				$objParticipanteDTOUsuario = $objParticipanteDTO;
  				$numInteressadosUsuario++;
  			}
  		}
  
  		if ($numInteressadosUsuario==0){
  			$objInfraException->adicionarValidacao('Interessado no informado.');
  		}else if ($numInteressadosUsuario > 1){
  			$objInfraException->adicionarValidacao('Mais de um Interessado informado.');
  		}else{
  
  			//pode haver compartilhamento de contato
  			$objUsuarioDTO = new UsuarioDTO();
  			$objUsuarioDTO->setBolExclusaoLogica(false);
  			$objUsuarioDTO->setDistinct(true);
  			$objUsuarioDTO->retDblIdPessoaRh();
  			$objUsuarioDTO->retNumIdContato();
  			$objUsuarioDTO->retStrSigla();
  			$objUsuarioDTO->retStrNome();
  			$objUsuarioDTO->setNumIdContato($objParticipanteDTOUsuario->getNumIdContato());
  			$objUsuarioDTO->setOrdNumIdContato(InfraDTO::$TIPO_ORDENACAO_DESC);
  
  			$objUsuarioRN = new UsuarioRN();
  			$arrObjUsuarioDTO = $objUsuarioRN->listarRN0490($objUsuarioDTO);
  
  			if (count($arrObjUsuarioDTO)==0){
  				$objInfraException->lancarValidacao('Interessado no  um usurio.');
  			}
  
  			$arrIdPessoaRh = array();
  			foreach($arrObjUsuarioDTO as $objUsuarioDTOContato){
  				if ($objUsuarioDTOContato->getDblIdPessoaRh()!=null && !in_array($objUsuarioDTOContato->getDblIdPessoaRh(),$arrIdPessoaRh)){
  					$arrIdPessoaRh[] = $objUsuarioDTOContato->getDblIdPessoaRh();
  				}
  			}
  
  			if (count($arrIdPessoaRh)>1){
  				throw new InfraException('Usurio '.$arrObjUsuarioDTO[0]->getStrNome().' no contm identificador do RH nico.');
  
  				//Um ou mais ID PESSOA RH nulo
  			}else if (count($arrIdPessoaRh) == 0){
  
  				//pega primeiro
  				$arrIdContatos = array($arrObjUsuarioDTO[0]->getNumIdContato());
  
  				//ID PESSOA RH no nulo
  			}else{
  
  				//busca todos os contatos com o mesmo IdPessoaRh
  				$objUsuarioDTOContatos = new UsuarioDTO();
  				$objUsuarioDTOContatos->setBolExclusaoLogica(false);
  				$objUsuarioDTOContatos->retNumIdContato();
  				$objUsuarioDTOContatos->setDblIdPessoaRh($arrIdPessoaRh[0]);
  				$arrIdContatos = InfraArray::converterArrInfraDTO($objUsuarioRN->listarRN0490($objUsuarioDTOContatos),'IdContato');
  			}
  
  			$objUsuarioDTO = $arrObjUsuarioDTO[0];
  
  			if ($parObjProcedimentoDTO->getDblIdProcedimento()!=null){
  				$objProtocoloDTO = new ProtocoloDTO();
  				$objProtocoloDTO->retNumIdOrgaoUnidadeGeradora();
  				$objProtocoloDTO->retStrSiglaOrgaoUnidadeGeradora();
  				$objProtocoloDTO->setDblIdProtocolo($parObjProcedimentoDTO->getDblIdProcedimento());
  
  				$objProtocoloRN = new MdPetProtocoloRN();
  				$objProtocoloDTO = $objProtocoloRN->consultarRN0186($objProtocoloDTO);
  
  				$numIdOrgaoProtocolo = $objProtocoloDTO->getNumIdOrgaoUnidadeGeradora();
  				$strSiglaOrgaoProtocolo = $objProtocoloDTO->getStrSiglaOrgaoUnidadeGeradora();
  			}else{
  				$numIdOrgaoProtocolo = SessaoSEI::getInstance()->getNumIdOrgaoUnidadeAtual();
  				$strSiglaOrgaoProtocolo = SessaoSEI::getInstance()->getStrSiglaOrgaoUnidadeAtual();
  			}
  
  			$objProtocoloDTO = new ProtocoloDTO();
  			$objProtocoloDTO->retDblIdProtocolo();
  			$objProtocoloDTO->retStrProtocoloFormatado();
  			$objProtocoloDTO->setNumTipoFkProcedimento(InfraDTO::$TIPO_FK_OBRIGATORIA);
  			$objProtocoloDTO->setNumIdContatoParticipante($arrIdContatos, InfraDTO::$OPER_IN);
  			$objProtocoloDTO->setStrStaParticipacaoParticipante(ParticipanteRN::$TP_INTERESSADO);
  			$objProtocoloDTO->setNumIdTipoProcedimentoProcedimento($parObjProcedimentoDTO->getNumIdTipoProcedimento());
  			$objProtocoloDTO->setDblIdProtocolo($parObjProcedimentoDTO->getDblIdProcedimento(),InfraDTO::$OPER_DIFERENTE);
  			$objProtocoloDTO->setNumIdOrgaoUnidadeGeradora($numIdOrgaoProtocolo);
  			$objProtocoloDTO->setOrdDblIdProtocolo(InfraDTO::$TIPO_ORDENACAO_DESC);
  
  			$objProtocoloRN = new MdPetProtocoloRN();
  			$arrObjProtocoloDTOTemp = $objProtocoloRN->listarRN0668($objProtocoloDTO);
  
  			$arrObjProtocoloDTO = array();
  			$objParticipanteRN = new ParticipanteRN();
  			foreach($arrObjProtocoloDTOTemp as $objProtocoloDTO){
  
  				$objParticipanteDTO = new ParticipanteDTO();
  				$objParticipanteDTO->setDblIdProtocolo($objProtocoloDTO->getDblIdProtocolo());
  				$objParticipanteDTO->setStrStaParticipacao(ParticipanteRN::$TP_INTERESSADO);
  
  				if ($objParticipanteRN->contarRN0461($objParticipanteDTO)==1){
  					$arrObjProtocoloDTO[] = $objProtocoloDTO;
  				}
  			}
  
  			$numProtocolos = count($arrObjProtocoloDTO);
  			if ($numProtocolos==1){
  				$objInfraException->adicionarValidacao('J existe um processo no rgo "'.$strSiglaOrgaoProtocolo.'" do tipo "'.$objTipoProcedimentoDTO->getStrNome().'" para o interessado "'.$objUsuarioDTO->getStrNome().'" com o n '.$arrObjProtocoloDTO[0]->getStrProtocoloFormatado().'.');
  			}else if ($numProtocolos>1){
  				$strMsg = 'Existem '.$numProtocolos.' processos no rgo "'.$strSiglaOrgaoProtocolo.'" do tipo "'.$objTipoProcedimentoDTO->getStrNome().'" para o interessado "'.$objUsuarioDTO->getStrNome().'":\n';
  				foreach($arrObjProtocoloDTO as $objProtocoloDTO){
  					$strMsg .= $objProtocoloDTO->getStrProtocoloFormatado().'\n';
  				}
  				$objInfraException->adicionarValidacao($strMsg);
  			}
  		}
  	}
  }
  
  //alteracoes seiv3
  //metodo foi removido, esta  uma versao migrada do seiv2
  //inicio
  protected function lancarAcessoControleInternoControlado(ProcedimentoDTO $objProcedimentoDTO){
    try{

      if ($objProcedimentoDTO->getStrStaNivelAcessoGlobalProtocolo()!=ProtocoloRN::$NA_SIGILOSO){

        $objControleInternoDTO = new ControleInternoDTO();
        $objControleInternoDTO->setDistinct(true);
        //alteracoes seiv3
        $objControleInternoDTO->retNumIdUnidadeControle();
        //seiv2
        //$objControleInternoDTO->retNumIdUnidadeRelControleInternoUnidade();
        
        //alteracoes seiv3
        $objControleInternoDTO->setNumIdTipoProcedimentoControlado( $objProcedimentoDTO->getNumIdTipoProcedimento() );
        //seiv2
        //$objControleInternoDTO->setNumIdTipoProcedimentoRelControleInternoTipoProc($objProcedimentoDTO->getNumIdTipoProcedimento());
        //alteracoes seiv3
        $objControleInternoDTO->setNumIdOrgaoControlado(SessaoSEI::getInstance()->getNumIdOrgaoUnidadeAtual());
        //seiv2
        //$objControleInternoDTO->setNumIdOrgaoRelControleInternoOrgao(SessaoSEI::getInstance()->getNumIdOrgaoUnidadeAtual());
        //alteracoes seiv3
        $objControleInternoDTO->setNumIdUnidadeControle(SessaoSEI::getInstance()->getNumIdUnidadeAtual(),InfraDTO::$OPER_DIFERENTE);
        //seiv2
         //$objControleInternoDTO->setNumIdUnidadeRelControleInternoUnidade(SessaoSEI::getInstance()->getNumIdUnidadeAtual(),InfraDTO::$OPER_DIFERENTE);

        $objControleInternoRN = new ControleInternoRN();
        $arrObjControleInternoDTO = $objControleInternoRN->listar($objControleInternoDTO);
        
        $objProtocoloRN = new ProtocoloRN();

        foreach($arrObjControleInternoDTO as $objControleInternoDTO){

          $objAtividadeDTO = new AtividadeDTO();
          $objAtividadeDTO->setDblIdProtocolo($objProcedimentoDTO->getDblIdProcedimento());
          $objAtividadeDTO->setNumIdUnidade($objControleInternoDTO->getNumIdUnidadeRelControleInternoUnidade());

          $objAtividadeRN = new AtividadeRN();

          if ($objAtividadeRN->contarRN0035($objAtividadeDTO)==0){

            $objAtividadeDTO->setNumIdTarefa(TarefaRN::$TI_ACESSO_AUTOMATICO_AO_PROCESSO);

            $objAtividadeRN->gerarInternaRN0727($objAtividadeDTO);


            //Associar o processo e seus documentos com esta unidade
            $objAssociarDTO = new AssociarDTO();
            $objAssociarDTO->setDblIdProcedimento($objProcedimentoDTO->getDblIdProcedimento());
            $objAssociarDTO->setDblIdDocumento(null);
            $objAssociarDTO->setNumIdUnidade($objControleInternoDTO->getNumIdUnidadeRelControleInternoUnidade());
            $objAssociarDTO->setNumIdUsuario(null);
            $objAssociarDTO->setStrStaNivelAcessoGlobal($objProcedimentoDTO->getStrStaNivelAcessoGlobalProtocolo());

            $objProtocoloRN->associarRN0982($objAssociarDTO);

          }
        }
      }
    }catch(Exception $e){
      throw new InfraException('Erro lanando acesso para o Controle Interno.',$e);
    }
  }
  //fim
  
}   
?>