<?
/**
* ANATEL
*
* 28/06/2016 - criado por marcelo.bezerra - CAST
*
*/

require_once dirname(__FILE__).'/../../../SEI.php';

class MdPetReciboIntercorrenteRN extends MdPetReciboRN {
	
	//mtodo utilizado para gerar recibo ao final do cadastramento de um processo de peticionamento de usuario externo
	protected function montarReciboControlado( $arrParams ){
		
		$reciboDTO = $arrParams[4];
		$arrDocumentos = $arrParams[5];

		//gerando documento recibo (nao assinado) dentro do processo do SEI
		$objInfraParametro = new InfraParametro($this->getObjInfraIBanco());
		
		$arrParametros = $arrParams[0]; //parametros adicionais fornecidos no formulario de peticionamento
		$objUnidadeDTO = $arrParams[1]; //UnidadeDTO da unidade geradora do processo
		$objProcedimentoDTO = $arrParams[2]; //ProcedimentoDTO para vincular o recibo ao processo correto
		$arrParticipantesParametro = $arrParams[3]; //array de ParticipanteDTO
		
		//tentando simular sessao de usuario interno do SEI
		SessaoSEI::getInstance()->setNumIdUnidadeAtual( $objUnidadeDTO->getNumIdUnidade() );
		SessaoSEI::getInstance()->setNumIdUsuario( SessaoSEIExterna::getInstance()->getNumIdUsuarioExterno() );
		
		$grauSigiloDocPrincipal = $arrParametros['grauSigiloDocPrincipal'];
		$hipoteseLegalDocPrincipal = $arrParametros['hipoteseLegalDocPrincipal'];

        $htmlRecibo = $this->gerarHTMLConteudoDocRecibo( $arrParams );

		$protocoloRN = new MdPetProtocoloRN();
		
		//$numeroDocumento = $protocoloRN->gerarNumeracaoDocumento();
		$idSerieRecibo = $objInfraParametro->getValor('ID_SERIE_RECIBO_MODULO_PETICIONAMENTO');
		
		//=============================================
		//MONTAGEM DO DOCUMENTO VIA SEI RN
		//=============================================
		
		$objDocumentoAPI = new DocumentoAPI();
		$objDocumentoAPI->setIdProcedimento( $objProcedimentoDTO->getDblIdProcedimento() );
		$objDocumentoAPI->setSubTipo( DocumentoRN::$TD_FORMULARIO_AUTOMATICO );
		$objDocumentoAPI->setTipo( ProtocoloRN::$TP_DOCUMENTO_GERADO );
		$objDocumentoAPI->setIdSerie( $idSerieRecibo );
		$objDocumentoAPI->setSinAssinado('N');
		$objDocumentoAPI->setSinBloqueado('S');
		$objDocumentoAPI->setIdHipoteseLegal( null );
		$objDocumentoAPI->setNivelAcesso( ProtocoloRN::$NA_PUBLICO );
		$objDocumentoAPI->setIdTipoConferencia( null );
		
		$objDocumentoAPI->setConteudo(base64_encode( utf8_encode($htmlRecibo)  ) );
		
		$objSeiRN = new SeiRN();
		$saidaDocExternoAPI = $objSeiRN->incluirDocumento( $objDocumentoAPI );
		
		//necessario forar update da coluna sta_documento da tabela documento
		//inclusao via SeiRN nao permitiu definir como documento de formulario automatico
		$parObjDocumentoDTO = new DocumentoDTO();
		$parObjDocumentoDTO->retTodos();
		$parObjDocumentoDTO->setDblIdDocumento( $saidaDocExternoAPI->getIdDocumento() );
		
		$docRN = new DocumentoRN();
		$parObjDocumentoDTO = $docRN->consultarRN0005( $parObjDocumentoDTO );
		$parObjDocumentoDTO->setStrStaDocumento( DocumentoRN::$TD_FORMULARIO_AUTOMATICO );
		$objDocumentoBD = new DocumentoBD($this->getObjInfraIBanco());
		$objDocumentoBD->alterar($parObjDocumentoDTO);
		
		$reciboDTO->setDblIdDocumento( $saidaDocExternoAPI->getIdDocumento() );
		
		$objBD = new MdPetReciboBD($this->getObjInfraIBanco());
		$reciboDTO = $objBD->alterar( $reciboDTO );

		return $parObjDocumentoDTO;

    }
  
    private function gerarHTMLConteudoDocRecibo( $arrParams ){
        $arrParametros      = $arrParams[0]; //parametros adicionais fornecidos no formulario de peticionamento
        $objUnidadeDTO      = $arrParams[1]; //UnidadeDTO da unidade geradora do processo
        $objProcedimentoDTO = $arrParams[2]; //ProcedimentoDTO para vincular o recibo ao processo correto
        $arrParticipantes   = $arrParams[3]; //array de ParticipanteDTO
        $reciboDTO          = $arrParams[4]; //MdPetReciboDTO
        $arrDocumentos      = $arrParams[5]; //MdPetReciboDTO

        $objUsuarioDTO = new UsuarioDTO();
        $objUsuarioDTO->retTodos(true);
        $objUsuarioDTO->setNumIdUsuario( $reciboDTO->getNumIdUsuario() );

        $objUsuarioRN = new UsuarioRN();
        $objUsuarioDTO = $objUsuarioRN->consultarRN0489( $objUsuarioDTO );

        $html = '';

        $html .= '<table align="center" style="width: 95%" border="0">';
        $html .= '<tbody><tr>';
        $html .= '<td style="font-weight: bold; width: 400px;">Usurio Externo (signatrio):</td>';
        $html .= '<td>' . $objUsuarioDTO->getStrNome() . '</td>';
        $html .= '</tr>';

        $html .= '<tr>';
        $html .= '<td style="font-weight: bold;">IP utilizado: </td>';
        $html .= '<td>' . $reciboDTO->getStrIpUsuario() .'</td>';
        $html .= '</tr>';

        $html .= '<tr>';
        $html .= '<td style="font-weight: bold;">Data e Horrio:</td>';
        $html .= '<td>' . $reciboDTO->getDthDataHoraRecebimentoFinal() .  '</td>';
        $html .= '</tr>';

        $html .= '<tr>';
        $html .= '<td style="font-weight: bold;">Tipo de Peticionamento:</td>';
        $html .= '<td>' . $reciboDTO->getStrStaTipoPeticionamentoFormatado() . '</td>';
        $html .= '</tr>';

        $html .= '<tr>';
        $html .= '<td style="font-weight: bold;">Nmero do Processo:</td>';
        $html .= '<td>' . $objProcedimentoDTO->getStrProtocoloProcedimentoFormatado() .  '</td>';
        $html .= '</tr>';
        
        if( $reciboDTO->isSetDblIdProtocoloRelacionado()) {
        	
        	$idProtocoloPrinc = $reciboDTO->getDblIdProtocoloRelacionado();
        
	        if(!(InfraString::isBolVazia($idProtocoloPrinc))){
	                
	        	$objProtocoloRN = new ProtocoloRN();
	        	$objProtocoloDTO = new ProtocoloDTO();
	        
	        	$objProtocoloDTO->setDblIdProtocolo($idProtocoloPrinc);
	        	$objProtocoloDTO->retTodos();
	        
	        	$objProtocoloDTO = $objProtocoloRN->consultarRN0186($objProtocoloDTO);
	        	$protocoloRelFormatado = $objProtocoloDTO->getStrProtocoloFormatado();
	        	
	        	//se houver processo relacionado
	        	$html .= '<tr>';
	        	$html .= '<td> &ensp;&nbsp; Relacionado ao Processo:</td>';
	        	$html .= '<td>' . $protocoloRelFormatado . '</td>';
	        	$html .= '</tr>';
	        
	        }
        
        }
        
        //obter interessados (apenas os do tipo interessado, nao os do tipo remetente)
        $arrInteressados = array();
        /*
        $objParticipanteDTO = new ParticipanteDTO();
        $objParticipanteDTO->setDblIdProtocolo( $reciboDTO->getNumIdProtocolo() );
        $objParticipanteDTO->setStrStaParticipacao( ParticipanteRN::$TP_INTERESSADO );
        $objParticipanteDTO->retNumIdContato();
        */
        $objParticipanteRN = new ParticipanteRN();
        //$arrObjParticipanteDTO = $objParticipanteRN->listarRN0189($objParticipanteDTO);

        foreach ($arrParticipantes as $objParticipanteDTO) {
            $objContatoDTO = new ContatoDTO();
            $objContatoDTO->setNumIdContato($objParticipanteDTO->getNumIdContato());
            $objContatoDTO->retStrNome();
            $objContatoRN      = new ContatoRN();
            $arrInteressados[] = $objContatoRN->consultarRN0324($objContatoDTO);
        }

        $html .= '<tr>';
        $html .= '<td colspan="2" style="font-weight: bold;">Interessados:</td>';
        $html .= '</tr>';

        if( $arrInteressados != null && count( $arrInteressados ) > 0 ){
            foreach ($arrInteressados as $interessado) {
               $html .= '<tr>';
               $html .= '<td colspan="2" >&nbsp&nbsp&nbsp&nbsp ' . $interessado->getStrNome() . '</td>';
               $html .= '</tr>';
             }
        }

        $html .= '<tr>';
        $html .= '<td style="font-weight: bold;">Protocolos dos Documentos (Nmero SEI):</td>';
        $html .= '<td></td>';
        $html .= '</tr>';
        /*
        $arr = PaginaSEI::getInstance()->getArrItensTabelaDinamica($arrParametros['hdnTbDocumento']);
        ob_start();
        var_dump($arr);
        var_dump($arrParams);
        $dump = ob_get_contents();
        ob_end_clean();

        $html .= $dump;
        */
        if( $arrDocumentos != null && count( $arrDocumentos ) > 0  ){
          foreach($arrDocumentos as $documentoDTO){
            $strNumeroSEI = $documentoDTO->getStrProtocoloDocumentoFormatado();
            //concatenar tipo e complemento
            $strNome = $documentoDTO->getStrNomeSerie() . ' ' . $documentoDTO->getStrNumero();
            $html .= '<tr>';
            $html .= '<td> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; - ' . $strNome . '</td>';
            $html .= '<td>' . $strNumeroSEI . '</td>';
            $html .= '</tr>';
          }
        }

        $html .= '</tbody></table>';

        $orgaoRN = new OrgaoRN();
        $objOrgaoDTO = new OrgaoDTO();
        $objOrgaoDTO->retTodos();
        $objOrgaoDTO->setNumIdOrgao( $objUnidadeDTO->getNumIdOrgao() );
        $objOrgaoDTO->setStrSinAtivo('S');
        $objOrgaoDTO = $orgaoRN->consultarRN1352( $objOrgaoDTO );

        $html .= '<p>O Usurio Externo acima identificado foi previamente avisado que o peticionamento importa na aceitao dos termos e condies que regem o processo eletrnico, alm do disposto no credenciamento prvio, e na assinatura dos documentos nato-digitais e declarao de que so autnticos os digitalizados, sendo responsvel civil, penal e administrativamente pelo uso indevido. Ainda, foi avisado que os nveis de acesso indicados para os documentos estariam condicionados  anlise por servidor pblico, que poder, motivadamente, alter-los a qualquer momento sem necessidade de prvio aviso, e de que so de sua exclusiva responsabilidade:</p><ul><li>a conformidade entre os dados informados e os documentos;</li><li>a conservao dos originais em papel de documentos digitalizados at que decaia o direito de reviso dos atos praticados no processo, para que, caso solicitado, sejam apresentados para qualquer tipo de conferncia;</li><li>a realizao por meio eletrnico de todos os atos e comunicaes processuais com o prprio Usurio Externo ou, por seu intermdio, com a entidade porventura representada;</li><li>a observncia de que os atos processuais se consideram realizados no dia e hora do recebimento pelo SEI, considerando-se tempestivos os praticados at as 23h59min59s do ltimo dia do prazo, considerado sempre o horrio oficial de Braslia, independente do fuso horrio em que se encontre;</li><li>a consulta peridica ao SEI, a fim de verificar o recebimento de intimaes eletrnicas.</li></ul><p>A existncia deste Recibo, do processo e dos documentos acima indicados pode ser conferida no Portal na Internet do(a) ' . $objOrgaoDTO->getStrDescricao() . '.</p>';
        return $html;
  }


	protected function gerarReciboSimplificadoIntercorrenteControlado($arr) {
		if(is_array($arr)){

			$idProcedimento    = array_key_exists('idProcedimento', $arr) ? $arr['idProcedimento'] : null;
			$idProcedimentoRel = array_key_exists('idProcedimentoRel', $arr) ? $arr['idProcedimentoRel'] : null;

				if(!is_null($idProcedimento))
				{
					$reciboDTO = new MdPetReciboDTO();

					$reciboDTO->setNumIdProtocolo( $idProcedimento );
					$reciboDTO->setNumIdUsuario( SessaoSEIExterna::getInstance()->getNumIdUsuarioExterno() );
					$reciboDTO->setDthDataHoraRecebimentoFinal( InfraData::getStrDataHoraAtual() );
					$reciboDTO->setStrIpUsuario( InfraUtil::getStrIpUsuario() );
					$reciboDTO->setStrSinAtivo('S');
					$reciboDTO->setStrStaTipoPeticionamento('I');

                    if(!is_null($idProcedimentoRel)){
						$reciboDTO->setDblIdProtocoloRelacionado($idProcedimentoRel);
					}

					$objBD = new MdPetReciboBD($this->getObjInfraIBanco());
					$ret = $objBD->cadastrar( $reciboDTO );
					return $ret;
				}
		}

		return null;
	}

}
?>